﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;
using FloralExpressCheckOut.Class;

namespace FloralExpressCheckOut.Admin
{
    public partial class product : System.Web.UI.Page
    {
        string connString = ConfigurationManager.ConnectionStrings["floralexpresscheckoutConnectionString"].ConnectionString;
        CartInfoRepository cartInfoRepository;
        ProductInfoRepository productInfoRepository;

        protected void Page_Load(object sender, EventArgs e)
        {
            cmdAdd.Visible = true;
            cartInfoRepository = new CartInfoRepository();
            productInfoRepository = new ProductInfoRepository();
            ShowProductInfo();
            
        }

        //Bind ProductInfo
        protected void ShowProductInfo()
        {
            List<Product> productInfo = new List<Product>();
            productInfo = productInfoRepository.GetProductInfos();
            lvProductInfo.DataSource = productInfo;
            lvProductInfo.DataBind();
        }

        //Show ProductInfo
        protected void EditProduct(object sender, CommandEventArgs e)
        {
            Product productInfo = new Product();
            int productId;
            productId=int.Parse((string)e.CommandArgument);
            productInfo=productInfoRepository.GetProductInfoByProductID(productId);
            txtName.Text = productInfo.ProductName;
            txtPrice.Text = productInfo.Price.ToString();
            txtPath.Text = productInfo.FilePath;
            litProductId.Text = productInfo.ProductID.ToString();
            cmdAdd.Visible = false;
            cmdEdit.Visible = true;
        }

        //Save ProductInfo
        protected void cmdEdit_Click(object sender, EventArgs e)
        {
            Product productInfo = new Product();
            productInfo.ProductID = int.Parse(litProductId.Text);
            productInfo.ProductName = txtName.Text;
            productInfo.FilePath = txtPath.Text;
            productInfo.Price = int.Parse(txtPrice.Text);
            productInfoRepository.UpdateProductInfoByProductId(productInfo);
            txtName.Text = "";
            txtPath.Text = "";
            txtPrice.Text = "";
            litProductId.Text = "";
            cmdAdd.Visible = true;
            cmdEdit.Visible = false;
            ShowProductInfo();

        }

        //Add ProductInfo
        protected void cmdAdd_Click(object sender, EventArgs e)
        {
            Product productInfo = new Product();
            productInfo.ProductName = txtName.Text;
            productInfo.FilePath = txtPath.Text;
            productInfo.Price = int.Parse(txtPrice.Text);
            productInfoRepository.InsertATMCardInfo(productInfo);
            txtName.Text = "";
            txtPath.Text = "";
            txtPrice.Text = "";
            ShowProductInfo();

        }

    }
}