﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Configuration;

namespace FloralExpressCheckOut.Class
{
    public class CartInfoRepository
    {   
        string connstr;
        public CartInfoRepository()
        {
            connstr = ConfigurationManager.ConnectionStrings["floralexpresscheckoutConnectionString"].ConnectionString;
        }

       
        #region // Get Methods

        public Cart GetCartInfoByProductIDAndMemberID(int productId,Guid memberId)
        {
            Cart currentCartInfo = new Cart();
            using (FloralDBDataContext dc = new FloralDBDataContext(connstr))
            {
                currentCartInfo = dc.GetCartInfoByProductIDAndMemberID(productId,memberId).FirstOrDefault();
            }
            return currentCartInfo;
        }

        public Cart GetCartInfoByProductID(int productId)
        {
            Cart currentCartInfo = new Cart();
            using (FloralDBDataContext dc = new FloralDBDataContext(connstr))
            {
                currentCartInfo = dc.GetCartInfoByProductID(productId).FirstOrDefault();
            }
            return currentCartInfo;
        }

        public Cart GetCartInfoByCartID(int cartId)
        {
            Cart currentCartInfo = new Cart();
            using (FloralDBDataContext dc = new FloralDBDataContext(connstr))
            {
                currentCartInfo = dc.GetCartInfoByCartID(cartId).FirstOrDefault();
            }
            return currentCartInfo;
        }

        public List<Cart> GetCartInfoByMemberID(Guid? memberId)
        {
            List<Cart> currentCartInfo = new List<Cart>();
            using (FloralDBDataContext dc = new FloralDBDataContext(connstr))
            {
                currentCartInfo = dc.GetCartInfoByMemberID(memberId).ToList();
            }
            return currentCartInfo;
        }

        #endregion

        #region // Insert Methods

        public void SaveCartInfo(Cart newCart)
        {
            using (FloralDBDataContext dc = new FloralDBDataContext(connstr))
            {
                dc.InsertCartInfo(newCart.MemberID, newCart.ProductID, newCart.Quantity, newCart.CartDate);
            }
        }

        #endregion

        #region // Update Methods

        public void UpdateCartInfo(Cart updateCart)
        {
            using (FloralDBDataContext dc = new FloralDBDataContext(connstr))
            {
                dc.UpdateCartInfo(updateCart.CartDate,updateCart.CartID,updateCart.Quantity);
            }
        }

        #endregion

        #region // Delete Methods

        public void DeleteCartInfo(int cartId)
        {
            using (FloralDBDataContext dc = new FloralDBDataContext(connstr))
            {
                dc.DeleteCartInfo(cartId);
            }
        }

        public void DeleteCartInfoByMemberId(Guid memberId)
        {
            using (FloralDBDataContext dc = new FloralDBDataContext(connstr))
            {
                dc.DeleteCartInfoByMemberId(memberId);
            }
        }

        #endregion

    }
}