﻿using System;
using System.Collections.Specialized;
using System.IO;
using System.Net;
using System.Text;
using System.Web;
using System.Collections.Generic;

namespace FloralExpressCheckOut.Class
{
    /// <summary>
    /// Summary description for NVPAPICaller
    /// </summary>
    public class MyanPaySoapCaller
    {

        //Calling MyanPay ExpressCheckout Soap Service
        EcService.EcServiceClient myService = new EcService.EcServiceClient();


        /// <summary> Initialize MyanPay Transaction : The method that calls SetExpressCheckout API, invoked from the
        /// 
        /// </summary>
        /// <param name="amt"></param>
        /// <param ref name="token"></param>
        /// <param ref name="retMsg"></param>
        /// <returns></returns>
        public bool SetExpressCheckOut(List<ProductInfoViewObject> allproductInfoViewObject, ShippingOptionViewObject shippingOptionViewObject,
            Orders ordersInfo, PaymentDetails paymentDetailsInfo, ShippingAddressSetting shippingAddressSettingInfo, BuyerDetailsInfo buyerDetailsInfo,
            ExpressCheckoutPageUiSetting sellerInfo, ref string token, ref string retMsg)
        {
            int i = 0;
            int ItemTotalAmount = 0;
            bool ret;

            EcService.SetExpressCheckOutRequest setecRequest = new EcService.SetExpressCheckOutRequest();
            EcService.SetExpressCheckOutResponse setEcResponse = new EcService.SetExpressCheckOutResponse();

            // Required Fields To Make SetExpressCheckout Request to MyanPay         
            setecRequest.ApiMethod = "SetExpressCheckout";
            setecRequest.ApiVersion = "1.1";
            setecRequest.CancelUrl = "http://localhost:20355/MyanPayGetExpressCheckout.aspx";
            setecRequest.ReturnUrl = "http://localhost:20355/MyanPayGetExpressCheckout.aspx";
            setecRequest.PaymentAction = "Sale";


            // Online Credentail
            EcService.MyanPayExpressCheckOutApiCredential checkoutCredential = new EcService.MyanPayExpressCheckOutApiCredential();

            checkoutCredential.ApiUserName = "_junio7482443442_myanpayAPI";
            checkoutCredential.ApiPassword = "Z687FL3W036I06D0";
            checkoutCredential.ApiSignature = "b98qL7734zo0Fw50mFP4u55p583bkLz44ZY524EMe5rO7hfdzlWq5AN2rx8d";

            setecRequest.MyanPayExpressCheckOutApiCredentialObject = new EcService.MyanPayExpressCheckOutApiCredential();

            setecRequest.MyanPayExpressCheckOutApiCredentialObject = checkoutCredential;

            #region Order ( Invoice ) Info

            foreach (ProductInfoViewObject productInfoViewObject in allproductInfoViewObject)
            {
                productInfoViewObject.ItemTotalAmount = productInfoViewObject.Quantity * productInfoViewObject.Price;
                ItemTotalAmount += productInfoViewObject.ItemTotalAmount;

            }

            EcService.PaymentDetailsInfo paymentDetailsInfoRequest = new EcService.PaymentDetailsInfo();

            paymentDetailsInfoRequest.PaymentRequesT_ShippingTotalAmt = paymentDetailsInfo.PaymentRequest_ShippingTotalAmt;
            paymentDetailsInfoRequest.PaymentRequest_ShipDiscAmt = paymentDetailsInfo.PaymentRequest_ShipDiscAmt;
            paymentDetailsInfoRequest.PaymentRequest_TaxTotalAmt = paymentDetailsInfo.PaymentRequest_TaxTotalAmt;
            paymentDetailsInfoRequest.PaymentRequest_HandlingTotalAmt = paymentDetailsInfo.PaymentRequest_HandlingTotalAmt;
            paymentDetailsInfoRequest.PaymentRequest_PaymentActionID = "1";

            paymentDetailsInfoRequest.PaymentRequest_Amt = paymentDetailsInfo.PaymentRequest_Amt;
            paymentDetailsInfoRequest.PaymentRequest_ItemTotalAmt = ItemTotalAmount;


            #region Payment Transaction Info

            paymentDetailsInfoRequest.PaymentRequest_TransactionID = paymentDetailsInfo.PaymentRequest_TransactionID;
            paymentDetailsInfoRequest.PaymentRequest_InvNum = paymentDetailsInfo.PaymentRequest_InvNum.ToString();
            paymentDetailsInfoRequest.PaymentRequest_Custom = paymentDetailsInfo.PaymentRequest_Custom.ToString();
            paymentDetailsInfoRequest.PaymentRequest_Desc = paymentDetailsInfo.PaymentRequest_Desc.ToString();
            paymentDetailsInfoRequest.PaymentRequest_NoteTxt = paymentDetailsInfo.PaymentRequest_NoteTxt.ToString();

            #endregion


            #region Insurance Info

            paymentDetailsInfoRequest.PaymentRequest_InsuranceTotalAmt = paymentDetailsInfo.PaymentRequest_InsuranceTotalAmt;
            paymentDetailsInfoRequest.PaymentRequest_InsuranceOptionOffered = paymentDetailsInfo.PaymentRequest_InsuranceOptionOffered;

            #endregion


            setecRequest.PaymentDetailsInfoObject = new EcService.PaymentDetailsInfo();

            setecRequest.PaymentDetailsInfoObject = paymentDetailsInfoRequest;

            #endregion

            #region Order Items Detail Info

            setecRequest.PaymentDetailsInfoObject.PaymentItemDetailsInfoObjects = new EcService.PaymentItemDetailsInfo[allproductInfoViewObject.Count];

            foreach (ProductInfoViewObject productInfoViewObject in allproductInfoViewObject)
            {
                EcService.PaymentItemDetailsInfo paymentItemDetailsInfoRequest = new EcService.PaymentItemDetailsInfo();

                paymentItemDetailsInfoRequest.PaymentRequest_ItemNumber = productInfoViewObject.ProductID.ToString();
                paymentItemDetailsInfoRequest.PaymentRequest_ItemName = productInfoViewObject.ProductName;
                paymentItemDetailsInfoRequest.PaymentRequest_ItemQty = productInfoViewObject.Quantity;
                paymentItemDetailsInfoRequest.PaymentRequest_ItemAmt = productInfoViewObject.Price;
                paymentItemDetailsInfoRequest.PaymentRequest_ItemDesc = productInfoViewObject.ProductName;
                paymentItemDetailsInfoRequest.PaymentRequest_ItemTaxAmt = 100;
                paymentItemDetailsInfoRequest.PaymentRequest_ItemWeightValue = "5";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemWeightUnit = "kg";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemLenghtValue = "2.54";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemLengthUnit = "cm";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemWidthValue = "10";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemWidthUnit = "cm";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemHeightValue = "20";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemHeightUnit = "cm";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemUrl = "";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemCategory = "";

                setecRequest.PaymentDetailsInfoObject.PaymentItemDetailsInfoObjects[i] = paymentItemDetailsInfoRequest;

                i++;
            }
               
            #endregion

            #region Shipping Option Info

            if (!shippingAddressSettingInfo.NoShipping)
            {
                int j = 0;
                setecRequest.ShippingOptionsObject = new EcService.ShippingOptions[shippingOptionViewObject.ShippingOptionsList.Count];

                foreach (var shippingOption in shippingOptionViewObject.ShippingOptionsList)
                {
                    EcService.ShippingOptions shippingOptionValue = new EcService.ShippingOptions();

                    shippingOptionValue.ShippingOptionAmount = shippingOption.ShippingOptionAmount;
                    shippingOptionValue.ShippingOptionName = shippingOption.ShippingOptionName;
                    shippingOptionValue.ShippingOptionLabel = shippingOption.ShippingOptionLabel;
                    shippingOptionValue.ShippingOptionIsDefault = shippingOption.ShippingOptionIsDefault;

                    setecRequest.ShippingOptionsObject[j] = shippingOptionValue;

                    j++;
                }
                
            }

            #endregion

            #region Shipping Address Setting

            EcService.ShippingAddressSetting shippingAddressSetting = new EcService.ShippingAddressSetting();

            setecRequest.ShippingAddressSettingObject = new EcService.ShippingAddressSetting();

            shippingAddressSetting.NoShipping = shippingAddressSettingInfo.NoShipping;
            shippingAddressSetting.CustomShipping = shippingAddressSettingInfo.CustomShipping;

            setecRequest.ShippingAddressSettingObject = shippingAddressSetting;

            if (!shippingAddressSettingInfo.NoShipping && shippingAddressSettingInfo.CustomShipping)
            {
                EcService.CustomDeliveryAddressObject customDeliveryAddressObj = new EcService.CustomDeliveryAddressObject();
                setecRequest.ShippingAddressSettingObject.CustomDeliveryAddressObject = new EcService.CustomDeliveryAddressObject();

                customDeliveryAddressObj.Name = shippingAddressSettingInfo.CustomDeliveryAddressObject.Name;
                customDeliveryAddressObj.Email = shippingAddressSettingInfo.CustomDeliveryAddressObject.Email;
                customDeliveryAddressObj.PhoneNumber = shippingAddressSettingInfo.CustomDeliveryAddressObject.Phonenumber;
                customDeliveryAddressObj.Address = shippingAddressSettingInfo.CustomDeliveryAddressObject.Address;
                customDeliveryAddressObj.City = shippingAddressSettingInfo.CustomDeliveryAddressObject.City;
                customDeliveryAddressObj.Country = shippingAddressSettingInfo.CustomDeliveryAddressObject.Country;

                setecRequest.ShippingAddressSettingObject.CustomDeliveryAddressObject = customDeliveryAddressObj;
            }
           

            #endregion

            #region Buyer Info

            EcService.BuyerDetailsInfo buyerDetailsInfoObject = new EcService.BuyerDetailsInfo();

            setecRequest.BuyerDetailsInfoObject = new EcService.BuyerDetailsInfo();

            buyerDetailsInfoObject.EcBuyerId = buyerDetailsInfo.EcBuyerId.ToString();
            buyerDetailsInfoObject.EcBuyerRegistrationDate = buyerDetailsInfo.EcBuyerRegistrationDate;
            buyerDetailsInfoObject.EcBuyerUserName = buyerDetailsInfo.EcBuyerUserName;

            setecRequest.BuyerDetailsInfoObject = buyerDetailsInfoObject;

            #endregion

            #region ExpressCheckout Page UI Setting

            EcService.ExpressCheckoutPageUiSetting ecPageUISetting = new EcService.ExpressCheckoutPageUiSetting();

            setecRequest.MyanPayExpressCheckOutPageUiSettingObject = new EcService.ExpressCheckoutPageUiSetting();

            ecPageUISetting.EcHeaderImage = sellerInfo.EcHeaderImage;
            ecPageUISetting.EcBrandName = sellerInfo.EcBrandName;
            ecPageUISetting.EcCustomerServiceNumber = sellerInfo.EcCustomerServiceNumber;

            setecRequest.MyanPayExpressCheckOutPageUiSettingObject = ecPageUISetting;

            #endregion


            // Check MyanPay SetExpressCheckout Response
            try
            {
                setEcResponse = myService.SetExpressCheckout(setecRequest);

                // Check MyanPay SetExpressCheckout Response
                string strAck = setEcResponse.Ack.ToString().ToLower();
                string myanPayExpressCheckoutLoginUrl = "https://www.myanpay-virtualbox.com/Personal/ExpressCheckout/ExpressCheckoutLogin.aspx";

                if (strAck != null && (strAck == "success" || strAck == "successwithwarning"))
                {
                    token = setEcResponse.Token;
                    string ECURL = myanPayExpressCheckoutLoginUrl + "?cmd=express-checkout" + "&token=" + token;

                    retMsg = ECURL;
                    ret = true;
                    return ret;
                }
                else
                {
                    retMsg = setEcResponse.ErrorLongMessage;
                    ret = false;
                    return ret;
                }


            }
            catch (Exception ex)
            {
                retMsg = ex.Message;
                ret = false;
                return ret;
            }
        }

        /// <summary> Get Shipping and Payer Information Details From MyanPay :The method that calls GetExpressCheckout API
        /// </summary>
        /// <param name="token"></param>
        /// <param ref name="retMsg"></param>
        /// <returns></returns>
        /// </summary>
        public bool GetExpressCheckout(string token, ref string strAck, ref PayerInfo payerInfo, ref ShippingAddressSetting shippingAddressSetting, ref ShippingOptions shippingOption, ref BuyerDetailsInfo buyerDetails, ref PaymentDetails paymentDetails, ref string retMsg)
        {
            EcService.GetExpressCheckOutRequest getEcRequest = new EcService.GetExpressCheckOutRequest();
            EcService.GetExpressCheckOutResponse getEcResponse = new EcService.GetExpressCheckOutResponse();

            getEcRequest.ApiMethod = "GetExpressCheckout";
            getEcRequest.ApiVersion = "1.1";
            getEcRequest.Token = token;

            EcService.MyanPayExpressCheckOutApiCredential checkoutCredential = new EcService.MyanPayExpressCheckOutApiCredential();

            checkoutCredential.ApiUserName = "_junio7482443442_myanpayAPI";
            checkoutCredential.ApiPassword = "Z687FL3W036I06D0";
            checkoutCredential.ApiSignature = "b98qL7734zo0Fw50mFP4u55p583bkLz44ZY524EMe5rO7hfdzlWq5AN2rx8d";

            getEcRequest.MyanPayExpressCheckOutApiCredentialObject = new EcService.MyanPayExpressCheckOutApiCredential();

            getEcRequest.MyanPayExpressCheckOutApiCredentialObject = checkoutCredential;

            // Check GetExpressCheckout Details 
            getEcResponse = myService.GetExpressCheckout(getEcRequest);

            strAck = getEcResponse.Ack.ToString();

            if (strAck != null && (strAck == "success" || strAck == "successwithwarning"))
            {
                #region Payer, ShippingAddress, BuyerDetails

                #region Payer Info

                if (getEcResponse.PayerInfo != null)
                {
                    payerInfo = new PayerInfo();

                    payerInfo.PrimaryEmailAddress = getEcResponse.PayerInfo.PrimaryEmailAddress;
                    payerInfo.PayerID = getEcResponse.PayerInfo.PayerID;
                    payerInfo.PayerStatus = getEcResponse.PayerInfo.PayerStatus;
                    payerInfo.BusinessCompanyName = getEcResponse.PayerInfo.BusinessCompanyName;
                    payerInfo.DisplayName = getEcResponse.PayerInfo.DisplayName;
                    payerInfo.PhoneNumber = getEcResponse.PayerInfo.PhoneNumber;
                }

                #endregion

                #region Shipping Address Setting

                if (getEcResponse.ShippingAddressSetting != null)
                {
                    shippingAddressSetting = new ShippingAddressSetting();

                    shippingAddressSetting.NoShipping = getEcResponse.ShippingAddressSetting.NoShipping;
                    shippingAddressSetting.CustomShipping = getEcResponse.ShippingAddressSetting.CustomShipping;

                    if (!shippingAddressSetting.NoShipping && shippingAddressSetting.CustomShipping)
                    {
                        shippingAddressSetting.CustomDeliveryAddressObject = new CustomDeliveryAddressObject();

                        shippingAddressSetting.CustomDeliveryAddressObject.Name = getEcResponse.ShippingAddressSetting.CustomDeliveryAddressObject.Name;
                        shippingAddressSetting.CustomDeliveryAddressObject.Email = getEcResponse.ShippingAddressSetting.CustomDeliveryAddressObject.Email;
                        shippingAddressSetting.CustomDeliveryAddressObject.Phonenumber = getEcResponse.ShippingAddressSetting.CustomDeliveryAddressObject.PhoneNumber;
                        shippingAddressSetting.CustomDeliveryAddressObject.Address = getEcResponse.ShippingAddressSetting.CustomDeliveryAddressObject.Address;
                        shippingAddressSetting.CustomDeliveryAddressObject.City = getEcResponse.ShippingAddressSetting.CustomDeliveryAddressObject.City;
                        shippingAddressSetting.CustomDeliveryAddressObject.Country = getEcResponse.ShippingAddressSetting.CustomDeliveryAddressObject.Country;
                    }

                    else if (!shippingAddressSetting.NoShipping && !shippingAddressSetting.CustomShipping)
                    {
                        shippingAddressSetting.ShippingAddressInfoObject = new ShippingAddressInfo();

                        shippingAddressSetting.ShippingAddressInfoObject.PaymentRequest_AddressLine = getEcResponse.ShippingAddressSetting.ShippingAddressInfoObject.PaymentRequest_AddressLine;
                        shippingAddressSetting.ShippingAddressInfoObject.PaymentRequest_ShipToCity = getEcResponse.ShippingAddressSetting.ShippingAddressInfoObject.PaymentRequest_ShipToCity;
                        shippingAddressSetting.ShippingAddressInfoObject.PaymentRequest_ShipToState = getEcResponse.ShippingAddressSetting.ShippingAddressInfoObject.PaymentRequest_ShipToState;
                    }
                }

                #endregion

                #region Shipping Option Info

                if (!getEcResponse.ShippingAddressSetting.NoShipping)
                {
                    if (getEcResponse.PaymentDetailsInfo.EcShippingOptionObjects != null)
                    {
                        shippingOption = new ShippingOptions();

                        shippingOption.ShippingOptionAmount = getEcResponse.PaymentDetailsInfo.EcShippingOptionObjects[0].EC_ShippingOptionAmount;
                        shippingOption.ShippingOptionIsDefault = getEcResponse.PaymentDetailsInfo.EcShippingOptionObjects[0].EC_ShippingOptionIsDefault;
                        shippingOption.ShippingOptionLabel = getEcResponse.PaymentDetailsInfo.EcShippingOptionObjects[0].EC_ShippingOptionLabel;
                        shippingOption.ShippingOptionName = getEcResponse.PaymentDetailsInfo.EcShippingOptionObjects[0].EC_ShippingOptionName;
                    }
                }

                #endregion

                #region Buyer Details Info

                if (getEcResponse.BuyerDetailsInfo != null)
                {
                    buyerDetails = new BuyerDetailsInfo();

                    buyerDetails.EcBuyerId = getEcResponse.BuyerDetailsInfo.EcBuyerId;
                    buyerDetails.EcBuyerUserName = getEcResponse.BuyerDetailsInfo.EcBuyerUserName;
                    buyerDetails.EcBuyerRegistrationDate = getEcResponse.BuyerDetailsInfo.EcBuyerRegistrationDate;

                }

                #endregion


                #endregion

                #region Payment and Payment Item Details

                #region Payment Details Info

                if (getEcResponse.PaymentDetailsInfo != null)
                {
                    paymentDetails.PaymentRequest_Amt = getEcResponse.PaymentDetailsInfo.ECinvoice_Amt;
                    paymentDetails.PaymentRequest_ItemTotalAmt = getEcResponse.PaymentDetailsInfo.ECinvoice_ItemTotalAmt;

                    if (!getEcResponse.ShippingAddressSetting.NoShipping)
                    {
                        paymentDetails.PaymentRequest_ShippingTotalAmt = getEcResponse.PaymentDetailsInfo.ECinvoice_ShippingTotalAmt;
                        paymentDetails.PaymentRequest_ShipDiscAmt = getEcResponse.PaymentDetailsInfo.ECinvoice_ShipDiscAmt;
                    }
                    if (getEcResponse.PaymentDetailsInfo.ECinvoice_InsuranceTotalAmt != null)
                    {
                        paymentDetails.PaymentRequest_InsuranceTotalAmt = getEcResponse.PaymentDetailsInfo.ECinvoice_InsuranceTotalAmt;
                    }

                    if (getEcResponse.PaymentDetailsInfo.ECinvoice_InsuranceOptionOffered != null)
                    {
                        paymentDetails.PaymentRequest_InsuranceOptionOffered = getEcResponse.PaymentDetailsInfo.ECinvoice_InsuranceOptionOffered;
                        paymentDetails.InsuranceOptionIsAcceptedByUser = getEcResponse.PaymentDetailsInfo.ECinvoice_IsInsuranceOptionAcceptedByUser.Value;
                    }

                    paymentDetails.PaymentRequest_HandlingTotalAmt = getEcResponse.PaymentDetailsInfo.ECinvoice_HandlingTotalAmt;
                    paymentDetails.PaymentRequest_TaxTotalAmt = getEcResponse.PaymentDetailsInfo.ECinvoice_TaxTotalAmt;
                    paymentDetails.PaymentRequest_Desc = getEcResponse.PaymentDetailsInfo.ECinvoice_Desc;
                    paymentDetails.PaymentRequest_Custom = getEcResponse.PaymentDetailsInfo.ECinvoice_Custom;
                    paymentDetails.PaymentRequest_InvNum = getEcResponse.PaymentDetailsInfo.ECinvoice_InvoiceIDByUser;
                    paymentDetails.PaymentRequest_NotifyUrl = getEcResponse.PaymentDetailsInfo.ECinvoice_NotifyUrl;
                    paymentDetails.PaymentRequest_NoteTxt = getEcResponse.PaymentDetailsInfo.ECinvoice_MessageToSeller;
                    paymentDetails.PaymentRequest_TransactionID = getEcResponse.PaymentDetailsInfo.ECinvoice_TransactionID;
                    paymentDetails.PaymentRequest_PaymentActionID = getEcResponse.PaymentDetailsInfo.ECinvoice_PaymentActionID.ToString();

                #endregion

                    #region Payment Item Details Info

                    if (getEcResponse.PaymentDetailsInfo.EcInvoiceItemDeepObjects != null)
                    {
                        paymentDetails.PaymentItemDetailsInfoObjects = new List<PaymentItemDetailsInfo>();

                        foreach (var eachInvoice in getEcResponse.PaymentDetailsInfo.EcInvoiceItemDeepObjects)
                        {
                            var paymentItemDetailsInfo = new PaymentItemDetailsInfo();

                            paymentItemDetailsInfo.PaymentRequest_ItemName = eachInvoice.ECinvoiceItem_Name;
                            paymentItemDetailsInfo.PaymentRequest_ItemAmt = eachInvoice.ECinvoiceItem_Amt;
                            paymentItemDetailsInfo.PaymentRequest_ItemQty = eachInvoice.ECinvoiceItem_Qty;
                            paymentItemDetailsInfo.PaymentRequest_ItemDesc = eachInvoice.ECinvoiceItem_Desc;
                            paymentItemDetailsInfo.PaymentRequest_ItemNumber = eachInvoice.ECinvoiceItem_Number;
                            paymentItemDetailsInfo.PaymentRequest_ItemTaxAmt = eachInvoice.ECinvoiceItem_TaxAmt.Value;
                            paymentItemDetailsInfo.PaymentRequest_ItemWeightUnit = eachInvoice.ECinvoiceItem_WeightUnitID;
                            paymentItemDetailsInfo.PaymentRequest_ItemWeightValue = eachInvoice.ECinvoiceItem_WeightValue;
                            paymentItemDetailsInfo.PaymentRequest_ItemLengthUnit = eachInvoice.ECinvoiceItem_LengthUnitID;
                            paymentItemDetailsInfo.PaymentRequest_ItemLenghtValue = eachInvoice.ECinvoiceItem_LengthValue;
                            paymentItemDetailsInfo.PaymentRequest_ItemHeightUnit = eachInvoice.ECinvoiceItem_HeightUnitID;
                            paymentItemDetailsInfo.PaymentRequest_ItemHeightValue = eachInvoice.ECinvoiceItem_HeightValue;
                            paymentItemDetailsInfo.PaymentRequest_ItemWidthUnit = eachInvoice.ECinvoiceItem_WidthUnitID;
                            paymentItemDetailsInfo.PaymentRequest_ItemWidthValue = eachInvoice.ECinvoiceItem_WidthValue;
                            paymentItemDetailsInfo.PaymentRequest_ItemUrl = eachInvoice.ECinvoiceItem_Url;
                            paymentItemDetailsInfo.PaymentRequest_ItemCategory = eachInvoice.ECinvoiceItem_Category;

                            paymentDetails.PaymentItemDetailsInfoObjects.Add(paymentItemDetailsInfo);
                        }

                    }

                    #endregion

                }

                #endregion

                return true;
            }
            else
            {
                retMsg = getEcResponse.ErrorLongMessage;

                return false;
            }

        }

        // <summary> Make transaction in MyanPay : The method that calls DoExpressCheckout API
        // </summary>
        // <param name="token"></param>
        // <param ref name="retMsg"></param>
        // <returns></returns>
        //</summary>
        public bool DoExpressCheckout(string token, string payerID, ShippingAddressSetting shippingAddressSettingInfo, PaymentDetails paymentDetailsInfo, ref PaymentTransactionInfo paymentTransactionInfo, ref BasicResponseField basicResponseField, ref string retMsg)
        {
            bool ret;

            #region Basic request fields

            EcService.DoExpressCheckOutRequest doEcRequest = new EcService.DoExpressCheckOutRequest();
            EcService.DoExpressCheckOutResponse doEcReponse = new EcService.DoExpressCheckOutResponse();

            doEcRequest.ApiMethod = "DoExpressCheckout";
            doEcRequest.ApiVersion = "1.1";
            doEcRequest.Token = token;
            doEcRequest.PayerID = payerID;
            doEcRequest.PaymentAction = "Sale";

            EcService.MyanPayExpressCheckOutApiCredential checkoutCredential = new EcService.MyanPayExpressCheckOutApiCredential();

            checkoutCredential.ApiUserName = "_junio7482443442_myanpayAPI";
            checkoutCredential.ApiPassword = "Z687FL3W036I06D0";
            checkoutCredential.ApiSignature = "b98qL7734zo0Fw50mFP4u55p583bkLz44ZY524EMe5rO7hfdzlWq5AN2rx8d";

            doEcRequest.MyanPayExpressCheckOutApiCredentialObject = checkoutCredential;

            #endregion

            #region Shipping Address Info


            EcService.ShippingAddressSetting shippingAddressSetting = new EcService.ShippingAddressSetting();

            doEcRequest.ShippingAddressSettingObject = new EcService.ShippingAddressSetting();

            shippingAddressSetting.NoShipping = shippingAddressSettingInfo.NoShipping;
            shippingAddressSetting.CustomShipping = shippingAddressSettingInfo.CustomShipping;

            doEcRequest.ShippingAddressSettingObject = shippingAddressSetting;

            if (!shippingAddressSettingInfo.NoShipping && shippingAddressSettingInfo.CustomShipping)
            {
                EcService.CustomDeliveryAddressObject customDeliveryAddressObj = new EcService.CustomDeliveryAddressObject();
                doEcRequest.ShippingAddressSettingObject.CustomDeliveryAddressObject = new EcService.CustomDeliveryAddressObject();

                customDeliveryAddressObj.Name = shippingAddressSettingInfo.CustomDeliveryAddressObject.Name;
                customDeliveryAddressObj.Email = shippingAddressSettingInfo.CustomDeliveryAddressObject.Email;
                customDeliveryAddressObj.PhoneNumber = shippingAddressSettingInfo.CustomDeliveryAddressObject.Phonenumber;
                customDeliveryAddressObj.Address = shippingAddressSettingInfo.CustomDeliveryAddressObject.Address;
                customDeliveryAddressObj.City = shippingAddressSettingInfo.CustomDeliveryAddressObject.City;
                customDeliveryAddressObj.Country = shippingAddressSettingInfo.CustomDeliveryAddressObject.Country;

                doEcRequest.ShippingAddressSettingObject.CustomDeliveryAddressObject = customDeliveryAddressObj;
            }
           
           

            #endregion

            decimal TotalAmountPerItem = 0;
            decimal AllTotalAmountForAllItems = 0;
            int i = 0;

            #region Order ( Invoice ) Info


            foreach (PaymentItemDetailsInfo eachpaymentItemDetailsInfo in paymentDetailsInfo.PaymentItemDetailsInfoObjects)
            {
                TotalAmountPerItem = eachpaymentItemDetailsInfo.PaymentRequest_ItemAmt *
                                    eachpaymentItemDetailsInfo.PaymentRequest_ItemQty;
                AllTotalAmountForAllItems += TotalAmountPerItem;
            }

            EcService.PaymentDetailsInfo paymentDetailsInfoRequest = new EcService.PaymentDetailsInfo();

            paymentDetailsInfoRequest.PaymentRequesT_ShippingTotalAmt = paymentDetailsInfo.PaymentRequest_ShippingTotalAmt;
            paymentDetailsInfoRequest.PaymentRequest_ShipDiscAmt = paymentDetailsInfo.PaymentRequest_ShipDiscAmt;
            paymentDetailsInfoRequest.PaymentRequest_TaxTotalAmt = paymentDetailsInfo.PaymentRequest_TaxTotalAmt;
            paymentDetailsInfoRequest.PaymentRequest_HandlingTotalAmt = paymentDetailsInfo.PaymentRequest_HandlingTotalAmt;
            paymentDetailsInfoRequest.PaymentRequest_PaymentActionID = "1";

            paymentDetailsInfoRequest.PaymentRequest_Amt = paymentDetailsInfo.PaymentRequest_Amt;
            paymentDetailsInfoRequest.PaymentRequest_ItemTotalAmt = AllTotalAmountForAllItems;

            #region Payment Transaction Info

            paymentDetailsInfoRequest.PaymentRequest_TransactionID = paymentDetailsInfo.PaymentRequest_TransactionID;
            paymentDetailsInfoRequest.PaymentRequest_InvNum = paymentDetailsInfo.PaymentRequest_InvNum.ToString();
            paymentDetailsInfoRequest.PaymentRequest_Custom = paymentDetailsInfo.PaymentRequest_Custom.ToString();
            paymentDetailsInfoRequest.PaymentRequest_Desc = paymentDetailsInfo.PaymentRequest_Desc.ToString();
            paymentDetailsInfoRequest.PaymentRequest_NoteTxt = paymentDetailsInfo.PaymentRequest_NoteTxt.ToString();

            #endregion


            #region Insurance Info

            paymentDetailsInfoRequest.PaymentRequest_InsuranceTotalAmt = paymentDetailsInfo.PaymentRequest_InsuranceTotalAmt;
            paymentDetailsInfoRequest.PaymentRequest_InsuranceOptionOffered = paymentDetailsInfo.PaymentRequest_InsuranceOptionOffered;

            #endregion


            doEcRequest.PaymentDetailsInfoObject = new EcService.PaymentDetailsInfo();

            doEcRequest.PaymentDetailsInfoObject = paymentDetailsInfoRequest;


            #endregion

            #region Order Items Detail Info

            doEcRequest.PaymentDetailsInfoObject.PaymentItemDetailsInfoObjects = new EcService.PaymentItemDetailsInfo[paymentDetailsInfo.PaymentItemDetailsInfoObjects.Count];

            foreach (PaymentItemDetailsInfo eachpaymentItemDetailsInfo in paymentDetailsInfo.PaymentItemDetailsInfoObjects)
            {
                EcService.PaymentItemDetailsInfo paymentItemDetailsInfoRequest = new EcService.PaymentItemDetailsInfo();

                paymentItemDetailsInfoRequest.PaymentRequest_ItemNumber = eachpaymentItemDetailsInfo.PaymentRequest_ItemNumber;
                paymentItemDetailsInfoRequest.PaymentRequest_ItemName = eachpaymentItemDetailsInfo.PaymentRequest_ItemName;
                paymentItemDetailsInfoRequest.PaymentRequest_ItemQty = eachpaymentItemDetailsInfo.PaymentRequest_ItemQty;
                paymentItemDetailsInfoRequest.PaymentRequest_ItemAmt = eachpaymentItemDetailsInfo.PaymentRequest_ItemAmt;
                paymentItemDetailsInfoRequest.PaymentRequest_ItemDesc = eachpaymentItemDetailsInfo.PaymentRequest_ItemDesc;
                paymentItemDetailsInfoRequest.PaymentRequest_ItemTaxAmt = 100;
                paymentItemDetailsInfoRequest.PaymentRequest_ItemWeightValue = "5";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemWeightUnit = "kg";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemLenghtValue = "2.54";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemLengthUnit = "cm";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemWidthValue = "10";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemWidthUnit = "cm";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemHeightValue = "20";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemHeightUnit = "cm";
                paymentItemDetailsInfoRequest.PaymentRequest_ItemUrl = eachpaymentItemDetailsInfo.PaymentRequest_ItemUrl;
                paymentItemDetailsInfoRequest.PaymentRequest_ItemCategory = eachpaymentItemDetailsInfo.PaymentRequest_ItemCategory;

                doEcRequest.PaymentDetailsInfoObject.PaymentItemDetailsInfoObjects[i] = paymentItemDetailsInfoRequest;
                i++;
            }


            #endregion

            // call the Do Expresscheckout method
            doEcReponse = myService.DoExpressCheckout(doEcRequest);

            string strAck = doEcReponse.Ack.ToString().ToLower();

            // Check Myanpay's DoExpressCheckOutResponse
            if (strAck != null && (strAck == "success" || strAck == "successwithwarning"))
            {
                basicResponseField = new BasicResponseField();

                basicResponseField.Ack = doEcReponse.Ack.ToString();
                basicResponseField.Build = doEcReponse.Build;
                basicResponseField.CorrelationID = doEcReponse.CorrelationID;
                basicResponseField.TimeStamp = doEcReponse.TimeStamp.ToString();
                basicResponseField.Token = doEcReponse.Token;
                basicResponseField.Version = doEcReponse.Version;

                #region Payment Transaction Info From MyanPay

                if (doEcReponse.MyanPayTransactionObject != null)
                {
                    paymentTransactionInfo = new PaymentTransactionInfo();

                    paymentTransactionInfo.PaymentInfo_TransactionId = doEcReponse.MyanPayTransactionObject.MyanPayTransactionID.ToString();
                    paymentTransactionInfo.PaymentInfo_TransactionTypeName = doEcReponse.MyanPayTransactionObject.MyanPayTransactionTypeName;
                    paymentTransactionInfo.PaymentInfo_TotalAmount = doEcReponse.MyanPayTransactionObject.NetAmount;
                    paymentTransactionInfo.PaymentInfo_OrderTime = doEcReponse.MyanPayTransactionObject.LastModifiedDate;
                    paymentTransactionInfo.PaymentInfo_PaymentStatusName = doEcReponse.MyanPayTransactionObject.MyanPayTransactionPaymentStatusName;
                    paymentTransactionInfo.PaymentInfo_TaxAmount = doEcReponse.MyanPayTransactionObject.TaxAmount;
                    paymentTransactionInfo.PaymentRequest_FeeAmount = doEcReponse.MyanPayTransactionObject.ChargesAmount;
                }

                #endregion

                ret = true;
            }
            else
            {
                retMsg = doEcReponse.ErrorLongMessage;
                ret = false;
            }
            return ret;
        }

    }
}