﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Configuration;


namespace FloralExpressCheckOut.Class
{
    
    public class ProductInfoRepository
    {
        string connstr;
        public ProductInfoRepository()
        {
          connstr = ConfigurationManager.ConnectionStrings["floralexpresscheckoutConnectionString"].ConnectionString;
        }

        #region //Get Methods

        public Product GetProductInfoByProductID(int productId)
        {
            Product currentProductInfo = new Product();
            using (FloralDBDataContext dc = new FloralDBDataContext(connstr))
            {
                currentProductInfo = dc.GetProductInfoByProductID(productId).FirstOrDefault();
            }
            return currentProductInfo;
        }

        public List<Product> GetProductInfos()
        {
            List<Product> currentProductInfos = new List<Product>();
            using (FloralDBDataContext dc = new FloralDBDataContext(connstr))
            {
                currentProductInfos = dc.GetProductInfos().ToList();
            }
            return currentProductInfos;
        }


        public List<Product> GetProductInfosByAscending()
        {
            List<Product> currentProductInfos = new List<Product>();
            using (FloralDBDataContext dc = new FloralDBDataContext(connstr))
            {
                currentProductInfos = dc.GetProductInfosByAscending().ToList();
            }
            return currentProductInfos;
        }



        #endregion

        #region // Update Methods

        public void UpdateProductInfoByProductId(Product productInfo)
        {
            using (FloralDBDataContext dc = new FloralDBDataContext(connstr))
            {
                dc.UpdateProductInfoByProductId(productInfo.ProductID,productInfo.ProductName,productInfo.Price,productInfo.FilePath);
            }
        }

        #endregion

        #region // Insert Methods

        public void InsertATMCardInfo(Product productInfo)
        {
            using (FloralDBDataContext dc = new FloralDBDataContext(connstr))
            {
                dc.InsertProductInfo(productInfo.ProductName, productInfo.Price, productInfo.FilePath);
            }
        }

        #endregion

    }

  
}