﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using FloralExpressCheckOut.Class;
using System.Configuration;

namespace FloralExpressCheckOut
{
	public partial class GetExpressCheckOutReview : System.Web.UI.Page
	{
        MyanPaySoapCaller _myanPaySoapCaller;
        PayerInfo _payerInfo;
        ShippingAddressSetting _shippingAddressSetting;
        ShippingOptions _shippingOption;
        BuyerDetailsInfo _buyerDetailsInfo;
        PaymentDetails _paymentDetailsInfo;
        
		protected void Page_Load(object sender, EventArgs e)
		{
            _myanPaySoapCaller = new MyanPaySoapCaller();
            _payerInfo = new PayerInfo();
            _shippingAddressSetting = new ShippingAddressSetting();
            _shippingOption = new ShippingOptions();
            _buyerDetailsInfo = new BuyerDetailsInfo();
            _paymentDetailsInfo = new PaymentDetails();

            Session["PayerID"] = Request.QueryString["PayerID"];
            string retMsg = "";
            string strAck = "";
            string token = (string)(Session["token" + ""]);

            if(token == Request.QueryString["token"])
            {
                bool ret = _myanPaySoapCaller.GetExpressCheckout(token, ref strAck, ref _payerInfo, ref _shippingAddressSetting, ref _shippingOption, ref _buyerDetailsInfo, ref _paymentDetailsInfo, ref retMsg);

                if (ret == true)
                {
                    #region Basic fields and Payer Info

                    litAck.Text = strAck;
                    litPrimaryEmailAddress.Text = _payerInfo.PrimaryEmailAddress;
                    litPayerID.Text = _payerInfo.PayerID;
                    litPayerStatus.Text = _payerInfo.PayerStatus;  
                    litBusinessCompanyName.Text = _payerInfo.BusinessCompanyName;
                    litDisplayName.Text = _payerInfo.DisplayName;
                    litPhoneNumber.Text = _payerInfo.PhoneNumber;
                    litToken.Text = token;

                    #endregion

                    #region Shipping Address Setting and Shipping Option

                   
                    litNoShipping.Text = _shippingAddressSetting.NoShipping.ToString();
                    litCustomShipping.Text = _shippingAddressSetting.CustomShipping.ToString();

                    litNoShippingInfo.Text = _shippingAddressSetting.NoShipping.ToString();
                    litCustomShippingInfo.Text = _shippingAddressSetting.CustomShipping.ToString();
                
                    if (!_shippingAddressSetting.NoShipping&&_shippingAddressSetting.CustomShipping
                        &&_shippingAddressSetting.CustomDeliveryAddressObject!=null)
                    {
                        pnlCustomDeliveryAddress.Visible = true;

                        litCustomDeliveryName.Text = _shippingAddressSetting.CustomDeliveryAddressObject.Name;
                        litCustomDeliveryEmail.Text = _shippingAddressSetting.CustomDeliveryAddressObject.Email;
                        litCustomDeliveryPhoneNo.Text = _shippingAddressSetting.CustomDeliveryAddressObject.Phonenumber;
                        litCustomDeliveryAddress.Text = _shippingAddressSetting.CustomDeliveryAddressObject.Address;
                        litCustomDeliveryCity.Text = _shippingAddressSetting.CustomDeliveryAddressObject.City;
                        litCustomDeliveryCountry.Text = _shippingAddressSetting.CustomDeliveryAddressObject.Country;

                        litCustomDeliveryNameInfo.Text = _shippingAddressSetting.CustomDeliveryAddressObject.Name;
                        litCustomDeliveryEmailInfo.Text = _shippingAddressSetting.CustomDeliveryAddressObject.Email;
                        litCustomDeliveryPhoneInfo.Text = _shippingAddressSetting.CustomDeliveryAddressObject.Phonenumber;
                        litCustomDeliveryAddressInfo.Text = _shippingAddressSetting.CustomDeliveryAddressObject.Address;
                        litCustomDeliveryCityInfo.Text = _shippingAddressSetting.CustomDeliveryAddressObject.City;
                        litCustomDeliveryCountryInfo.Text = _shippingAddressSetting.CustomDeliveryAddressObject.Country;
                    }

                    else if (!_shippingAddressSetting.NoShipping && !_shippingAddressSetting.CustomShipping)
                    {
                        pnlShippingAddress.Visible = true;

                        litShipToCity.Text = _shippingAddressSetting.ShippingAddressInfoObject.PaymentRequest_ShipToCity;
                        litShipToState.Text = _shippingAddressSetting.ShippingAddressInfoObject.PaymentRequest_ShipToState;
                        litAddressLine.Text = _shippingAddressSetting.ShippingAddressInfoObject.PaymentRequest_AddressLine;
                    }

                    // Shipping Option

                    if (!_shippingAddressSetting.NoShipping)
                    {
                        pnlShippingOption.Visible = true;

                        litShippingOptionIsDefault.Text = _shippingOption.ShippingOptionIsDefault.ToString();
                        litShippingOptionLabel.Text = _shippingOption.ShippingOptionLabel;
                        litShippingOptionName.Text = _shippingOption.ShippingOptionName;
                        litShippingOptionAmount.Text = _shippingOption.ShippingOptionAmount.ToString();

                        litShippingOptLabel.Text = _shippingOption.ShippingOptionLabel;
                        litShippingOptName.Text = _shippingOption.ShippingOptionName;
                        litShippingOptAmt.Text = _shippingOption.ShippingOptionAmount.ToString();
                    }

                    if (_paymentDetailsInfo.PaymentRequest_ShippingTotalAmt > 0)
                    {
                        litShippingDiscount.Text = _paymentDetailsInfo.PaymentRequest_ShipDiscAmt.ToString();
                    }

                    #endregion

                    #region Buyer Info

                    litEcBuyerId.Text = _buyerDetailsInfo.EcBuyerId;
                    litEcBuyerUserName.Text = _buyerDetailsInfo.EcBuyerUserName;
                    litEcBuyerRegistrationDate.Text = _buyerDetailsInfo.EcBuyerRegistrationDate.ToShortDateString();

                    litBuyerId.Text = _buyerDetailsInfo.EcBuyerId;
                    litBuyerName.Text = _buyerDetailsInfo.EcBuyerUserName;
                    litBuyerRegisDate.Text = _buyerDetailsInfo.EcBuyerRegistrationDate.ToShortDateString();

                    #endregion

                    #region Payment Details Info

                    litPaymentRequestTaxTotalAmt.Text = _paymentDetailsInfo.PaymentRequest_TaxTotalAmt.ToString();
                    litPaymentRequestAmt.Text = _paymentDetailsInfo.PaymentRequest_Amt.ToString();
                    litPaymentRequestItemTotalAmt.Text = _paymentDetailsInfo.PaymentRequest_ItemTotalAmt.ToString();

                    litItemAmountInfo.Text = _paymentDetailsInfo.PaymentRequest_ItemTotalAmt.ToString();
                    litTaxAmount.Text = _paymentDetailsInfo.PaymentRequest_TaxTotalAmt.ToString();
                    litHandlingAmount.Text = _paymentDetailsInfo.PaymentRequest_HandlingTotalAmt.ToString();
                    litTotalAmount.Text = _paymentDetailsInfo.PaymentRequest_Amt.ToString();


                    if (!_paymentDetailsInfo.PaymentRequest_InsuranceOptionOffered)
                    {
                        pnlInsuranceOptionIsAcceptedByUser.Visible = false;
                    }
                   

                    if (_paymentDetailsInfo.PaymentRequest_InsuranceOptionOffered&&!_paymentDetailsInfo.InsuranceOptionIsAcceptedByUser)
                    {
                        pnlInsuranceTotalAmt.Visible = false;
                    }
                    else
                    {
                        litInsuranceTotalAmt.Text = _paymentDetailsInfo.PaymentRequest_InsuranceTotalAmt.ToString();
                    }

                    litInsuranceOptionOffer.Text = _paymentDetailsInfo.PaymentRequest_InsuranceOptionOffered.ToString();
                    litInsuranceOptionIsAcceptedByUser.Text = _paymentDetailsInfo.InsuranceOptionIsAcceptedByUser.ToString();

                    if (!_shippingAddressSetting.NoShipping)
                    {
                        pnlShippingInfo.Visible = true;
                        litPaymentRequestShippingTotalAmt.Text = _paymentDetailsInfo.PaymentRequest_ShippingTotalAmt.ToString();
                        litPaymentRequestShippingDiscAmt.Text = _paymentDetailsInfo.PaymentRequest_ShipDiscAmt.ToString();
                    }
                    else
                    {
                        pnlShippingInfo.Visible = false;
                    }
                   
                    litPaymentRequestTransactionId.Text = _paymentDetailsInfo.PaymentRequest_TransactionID;                   
                    litPaymentRequestCustom.Text = _paymentDetailsInfo.PaymentRequest_Custom;
                    litPaymentRequestDesc.Text = _paymentDetailsInfo.PaymentRequest_Desc;
                    litPaymentRequestHandlingTotalAmt.Text = _paymentDetailsInfo.PaymentRequest_HandlingTotalAmt.ToString();
                    litPaymentRequestInsuranceOptionOffered.Text = _paymentDetailsInfo.PaymentRequest_InsuranceOptionOffered.ToString();
                    litPaymentRequestInsuranceTotalAmt.Text = _paymentDetailsInfo.PaymentRequest_InsuranceTotalAmt.ToString();
                    litPaymentRequestItemCount.Text = _paymentDetailsInfo.PaymentItemDetailsInfoObjects.Count.ToString();
                    litPaymentAction.Text = _paymentDetailsInfo.PaymentRequest_PaymentActionID.ToString();


                    litTransactionId.Text = _paymentDetailsInfo.PaymentRequest_TransactionID;
                    litCustom.Text = _paymentDetailsInfo.PaymentRequest_Custom;
                    litInvoiceNo.Text = _paymentDetailsInfo.PaymentRequest_InvNum;
                    litPaymentdesc.Text = _paymentDetailsInfo.PaymentRequest_Desc;

                    #endregion


                    Session["paymentDetails"] = _paymentDetailsInfo;

                    #region ShowCartInfo

                    lvCartInfo.DataSource = _paymentDetailsInfo.PaymentItemDetailsInfoObjects;
                    lvCartInfo.DataBind();

                    litAllTotal.Text = _paymentDetailsInfo.PaymentRequest_ItemTotalAmt.ToString();
                    
                  
                    pnlCartInfo.Visible = true;
                    #endregion

                }
                else
                {
                    Response.Write(retMsg);
                }
            }
		}

        protected void btnPayNow_Click(object sender, EventArgs e)
        {
            bool ret;
            string retMsg = "";
            string token = (string)(Session["token" +
                                            ""]);
            PaymentTransactionInfo paymentTransactionInfo = new PaymentTransactionInfo();
            BasicResponseField basicResponseField = new BasicResponseField();

            string payerID = (string) (Session["PayerID"]);

            // Call DoExpressCheckout API Call
            _paymentDetailsInfo = (PaymentDetails) Session["paymentDetails"];
            basicResponseField = (BasicResponseField) Session["BasicResponseField"];

            ret = _myanPaySoapCaller.DoExpressCheckout(token, payerID, _shippingAddressSetting, _paymentDetailsInfo, ref paymentTransactionInfo, ref basicResponseField, ref retMsg);
            if (ret == true)
            {
                Session["PaymentDetail"] = paymentTransactionInfo;
                Session["BasicResponseField"] = basicResponseField;
                Response.Redirect("~/PaymentCompleted.aspx");
            }
            else
            {
                Response.Write(retMsg);
            }
        }

        protected void lvCartInfo_ItemDataBound(object sender, ListViewItemEventArgs e)
        {

            Literal litWeightValue = e.Item.FindControl("litWeightValue") as Literal;
            Literal litLenghtValue = e.Item.FindControl("litLenghtValue") as Literal;
            Literal litWidthValue = e.Item.FindControl("litWidthValue") as Literal;
            Literal litHeightValue = e.Item.FindControl("litHeightValue") as Literal;

             #region Payment Item Details Info

            if (_paymentDetailsInfo != null)
            {
                foreach (PaymentItemDetailsInfo itemInfo in _paymentDetailsInfo.PaymentItemDetailsInfoObjects)
                {
                    litWeightValue.Text = itemInfo.PaymentRequest_ItemWeightValue + "&nbsp;" + itemInfo.PaymentRequest_ItemWeightUnit;
                    litLenghtValue.Text = itemInfo.PaymentRequest_ItemLenghtValue + "&nbsp;" + itemInfo.PaymentRequest_ItemLengthUnit;
                    litWidthValue.Text = itemInfo.PaymentRequest_ItemWidthValue + "&nbsp;" + itemInfo.PaymentRequest_ItemWidthUnit;
                    litHeightValue.Text = itemInfo.PaymentRequest_ItemHeightValue + "&nbsp;" + itemInfo.PaymentRequest_ItemHeightUnit;
                }
            }

             #endregion
        }       
	}
}