﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;
using FloralExpressCheckOut.Class;
using System.Text.RegularExpressions;

namespace FloralExpressCheckOut
{
    public partial class payInfo : System.Web.UI.Page
    {
        CartInfoRepository _cartInfoRepository;
        ProductInfoRepository _productInfoRepository;
        OrdersInfoRepository _ordersInfoRepository;
        OrderItemInfoRepository _orderItemInfoRepository;
        List<ProductInfoViewObject> _allproductInfoViewObject;
        OrderItem _orderItemInfo;
        Orders _ordersInfo;
        ShippingAddressSetting _shippingAddressSetting;
        ShippingOptionViewObject _shippingOptionViewObject;
        ExpressCheckoutPageUiSetting _ecPageUiSetting;
        BuyerDetailsInfo _buyerDetailsInfo;
        PaymentDetails _paymentDetailsInfo;
      
        int _totalAmount = 0;
        int _totalQty = 0;
        decimal shippingTotalAmt = 0;
        

        protected void Page_Load(object sender, EventArgs e)
        {
            _cartInfoRepository = new CartInfoRepository();
            _productInfoRepository = new ProductInfoRepository();
            _ordersInfoRepository = new OrdersInfoRepository();
            _orderItemInfoRepository = new OrderItemInfoRepository();
            _allproductInfoViewObject = new List<ProductInfoViewObject>();
            _orderItemInfo = new OrderItem();
            _ordersInfo = new Orders();
            _shippingAddressSetting = new ShippingAddressSetting();
            _shippingOptionViewObject = new ShippingOptionViewObject();
            _ecPageUiSetting = new ExpressCheckoutPageUiSetting();
            _buyerDetailsInfo = new BuyerDetailsInfo();
            _paymentDetailsInfo = new PaymentDetails();

            _shippingOptionViewObject.ShippingOptionsList = new List<ShippingOptions>();

            #region Adding shipping options to list

            ShippingOptions shippingOpt1 = new ShippingOptions();
            shippingOpt1.ShippingOptionLabel = ShippingOptionLabel0.Value;
            shippingOpt1.ShippingOptionName = ShippingOptionName0.Value;
            shippingOpt1.ShippingOptionAmount = decimal.Parse(ShippingOptionAmount0.Value);
            _shippingOptionViewObject.ShippingOptionsList.Add(shippingOpt1);

            ShippingOptions shippingOpt2 = new ShippingOptions();
            shippingOpt2.ShippingOptionLabel = ShippingOptionLabel1.Value;
            shippingOpt2.ShippingOptionName = ShippingOptionName1.Value;
            shippingOpt2.ShippingOptionAmount = decimal.Parse(ShippingOptionAmount1.Value);
            _shippingOptionViewObject.ShippingOptionsList.Add(shippingOpt2);

            ShippingOptions shippingOpt3 = new ShippingOptions();
            shippingOpt3.ShippingOptionLabel = ShippingOptionLabel2.Value;
            shippingOpt3.ShippingOptionName = ShippingOptionName2.Value;
            shippingOpt3.ShippingOptionAmount = decimal.Parse(ShippingOptionAmount2.Value);
            _shippingOptionViewObject.ShippingOptionsList.Add(shippingOpt3);

            ShippingOptions shippingOpt4 = new ShippingOptions();
            shippingOpt4.ShippingOptionLabel = ShippingOptionLabel3.Value;
            shippingOpt4.ShippingOptionName = ShippingOptionName3.Value;
            shippingOpt4.ShippingOptionAmount = decimal.Parse(ShippingOptionAmount3.Value);
            _shippingOptionViewObject.ShippingOptionsList.Add(shippingOpt4);

            ShippingOptions shippingOpt5 = new ShippingOptions();
            shippingOpt5.ShippingOptionLabel = ShippingOptionLabel4.Value;
            shippingOpt5.ShippingOptionName = ShippingOptionName4.Value;
            shippingOpt5.ShippingOptionAmount = decimal.Parse(ShippingOptionAmount4.Value);
            _shippingOptionViewObject.ShippingOptionsList.Add(shippingOpt5);


            #endregion

            
            if (!Page.IsPostBack)
            {
                ShowCartInfo();

                if (txtShipEmail.Text != string.Empty)
                {
                    bool emailFormatChecked = CheckIsValidEmail(txtShipEmail.Text);
                    if (!emailFormatChecked)
                    {
                        lblShipEmailValid.Text = "Please enter valid email format.";
                    }
                    else
                    {
                        lblShipEmailValid.Text = string.Empty;
                    }
                }

            }
        }

        #region Check email is valid or not

        public static bool CheckIsValidEmail(string email)
        {
            email.Trim();
            string Email = @"\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*?";
            Regex emailRegEx = new Regex(Email);
            return emailRegEx.IsMatch(email);
        }

        #endregion

        #region Show Cart Info

        protected void ShowCartInfo()
        {
            Guid?  memberId = null;
            if (Session["floralMID"] != null)
            {
                memberId = (Guid)Session["floralMID"];
            }

            List<Cart> allCartInfoBymemberId = new List<Cart>();
            allCartInfoBymemberId = _cartInfoRepository.GetCartInfoByMemberID(memberId);

            //List<ProductInfoViewObject> allpoductInfoViewObject = new List<ProductInfoViewObject>();
            int no = 1;

            foreach (Cart cartInfoBymemeberId in allCartInfoBymemberId)
            {
                ProductInfoViewObject productInfoViewObject = new ProductInfoViewObject();

                Product currentProductInfo = new Product();
                currentProductInfo = _productInfoRepository.GetProductInfoByProductID(cartInfoBymemeberId.ProductID);
                productInfoViewObject.ProductID = currentProductInfo.ProductID;
                productInfoViewObject.ProductName = currentProductInfo.ProductName;
                productInfoViewObject.Price = currentProductInfo.Price;
                productInfoViewObject.FilePath = currentProductInfo.FilePath;
                productInfoViewObject.Quantity = cartInfoBymemeberId.Quantity;
                productInfoViewObject.CartID = cartInfoBymemeberId.CartID;
                productInfoViewObject.ItemTotalAmount = productInfoViewObject.Price * productInfoViewObject.Quantity;
                productInfoViewObject.No = no++;
                _totalQty += productInfoViewObject.Quantity;
                _totalAmount += productInfoViewObject.ItemTotalAmount;
                _allproductInfoViewObject.Add(productInfoViewObject);

            }
            litItemAmountInfo.Text = _totalAmount.ToString();
            litShoppingCartQty.Text = _totalQty.ToString();
            litShoppingCartTotal.Text = _totalAmount.ToString();
            litShowItemAmt.Text = _totalAmount.ToString();
            //Bind cart info in list view
            lvCartInfo.DataSource = _allproductInfoViewObject;
            lvCartInfo.DataBind();

            if (optShipping0.Checked)
            {
                shippingTotalAmt = decimal.Parse(ShippingOptionAmount0.Value);
            }
            if (optShipping1.Checked)
            {
                shippingTotalAmt = decimal.Parse(ShippingOptionAmount1.Value);
            }
            if (optShipping2.Checked)
            {
                shippingTotalAmt = decimal.Parse(ShippingOptionAmount2.Value);
            }
            if (optShipping3.Checked)
            {
                shippingTotalAmt = decimal.Parse(ShippingOptionAmount3.Value);
            }
            if (optShipping4.Checked)
            {
                shippingTotalAmt = decimal.Parse(ShippingOptionAmount4.Value);
            }

            litInsuranceTotalAmtInfo.Text = InsuranceTotalAmt.Value;

            if (ddlNoShipping.SelectedValue == "true")
            {
                litShippingTotalAmtInfo.Text = "0";
                litShippingDiscAmt.Value = "0";
                litShippintDiscAmtInfo.Text = "0";

                litTotalAmount.Text = (decimal.Parse(litItemAmountInfo.Text) + decimal.Parse(litTaxTotalAmtInfo.Value) + decimal.Parse(InsuranceTotalAmt.Value) +
               decimal.Parse(litHandlingTotalAmtInfo.Value) + decimal.Parse(litShippingTotalAmtInfo.Text) + decimal.Parse(litShippingDiscAmt.Value)).ToString();

            }
            else if (ddlNoShipping.SelectedValue == "false")
            {

                litShippingTotalAmtInfo.Text = shippingTotalAmt.ToString();
                litShippingDiscAmt.Value = "-100";
                litShippintDiscAmtInfo.Text = "-100";

                litTotalAmount.Text = (decimal.Parse(litItemAmountInfo.Text) + decimal.Parse(litTaxTotalAmtInfo.Value) + decimal.Parse(InsuranceTotalAmt.Value) +
               decimal.Parse(litHandlingTotalAmtInfo.Value) + shippingTotalAmt + decimal.Parse(litShippingDiscAmt.Value)).ToString();

            }
           
            //litMaxAmountInfo.Text = ((decimal.Parse(litTotalAmount.Text) - shippingTotalAmt) + decimal.Parse(ShippingOptionAmount0.Value)).ToString();
            pnlCartInfo.Visible = true;
        }

        #endregion

        #region Clear Cart Info

        protected void lnkClearCart_Click(object sender, EventArgs e)
        {
            Guid memberId;
            memberId = (Guid)Session["floralMID"];
            _cartInfoRepository.DeleteCartInfoByMemberId(memberId);
            Response.Redirect("default.aspx");

        }

        #endregion

        protected void imgBtnCheckOut_Click(object sender, ImageClickEventArgs e)
        {

            #region Order Details Info

            int ordersId;
            _ordersInfo.MemberID = (Guid)Session["floralMID"];
            _ordersInfo.OrderDate = DateTime.UtcNow.AddMinutes(390);
            _ordersInfo.OrderUpdate = DateTime.UtcNow.AddMinutes(390);
            ordersId = _ordersInfoRepository.InsertOrdersInfo(_ordersInfo);


            List<Cart> allCartInfoBymemberId = new List<Cart>();
            allCartInfoBymemberId = _cartInfoRepository.GetCartInfoByMemberID((Guid)Session["floralMID"]);

            foreach (Cart cartInfoBymemeberId in allCartInfoBymemberId)
            {
                _orderItemInfo.OrderID = ordersId;
                _orderItemInfo.ProductID = cartInfoBymemeberId.ProductID;
                _orderItemInfo.Quantity = cartInfoBymemeberId.Quantity;
                _orderItemInfoRepository.InsertOrderItemInfo(_orderItemInfo);
            }

            ShowCartInfo();

            #endregion

            #region Shipping  Option Info

            if (ddlNoShipping.SelectedValue == "false")
            {
                if (optShipping0.Checked)
                {
                    _shippingOptionViewObject.ShippingOptionsList[0].ShippingOptionIsDefault = true;
                }
                else
                {
                    _shippingOptionViewObject.ShippingOptionsList[0].ShippingOptionIsDefault = false;
                }

                if (optShipping1.Checked)
                {
                    _shippingOptionViewObject.ShippingOptionsList[1].ShippingOptionIsDefault = true;
                }
                else
                {
                    _shippingOptionViewObject.ShippingOptionsList[1].ShippingOptionIsDefault = false;
                }

                if (optShipping2.Checked)
                {
                    _shippingOptionViewObject.ShippingOptionsList[2].ShippingOptionIsDefault = true;
                }
                else
                {
                    _shippingOptionViewObject.ShippingOptionsList[2].ShippingOptionIsDefault = false;
                }

                if (optShipping3.Checked)
                {
                    _shippingOptionViewObject.ShippingOptionsList[3].ShippingOptionIsDefault = true;
                }
                else
                {
                    _shippingOptionViewObject.ShippingOptionsList[3].ShippingOptionIsDefault = false;
                }

                if (optShipping4.Checked)
                {
                    _shippingOptionViewObject.ShippingOptionsList[0].ShippingOptionIsDefault = true;
                }
                else
                {
                    _shippingOptionViewObject.ShippingOptionsList[0].ShippingOptionIsDefault = false;
                }
            }
            else
            {
                _shippingOptionViewObject.ShippingOptionsList = null;
            }


            #endregion

            #region Shipping Address Info

            if (ddlNoShipping.SelectedValue == "false" && ddlCustomShipping.SelectedValue == "true")
            {
                _shippingAddressSetting.NoShipping = false;
                _shippingAddressSetting.CustomShipping = true;
                _shippingAddressSetting.CustomDeliveryAddressObject = new CustomDeliveryAddressObject();

                if (txtShipName.Text.Trim() != string.Empty)
                {
                    _shippingAddressSetting.CustomDeliveryAddressObject.Name = txtShipName.Text;
                }
                if (txtShipEmail.Text.Trim() != string.Empty)
                {
                    _shippingAddressSetting.CustomDeliveryAddressObject.Email = txtShipEmail.Text;
                }
                if (txtShipPhone.Text.Trim() != string.Empty)
                {
                    _shippingAddressSetting.CustomDeliveryAddressObject.Phonenumber = txtShipPhone.Text;
                }
                if (txtShipAddress.Text.Trim() != string.Empty)
                {
                    _shippingAddressSetting.CustomDeliveryAddressObject.Address = txtShipAddress.Text;
                }
                if (txtShipCity.Text.Trim() != string.Empty)
                {
                    _shippingAddressSetting.CustomDeliveryAddressObject.City = txtShipCity.Text;
                }
                if (txtShipCountry.Text.Trim() != string.Empty)
                {
                    _shippingAddressSetting.CustomDeliveryAddressObject.Country = txtShipCountry.Text;
                }
            }
            else if (ddlNoShipping.SelectedValue == "false" && ddlCustomShipping.SelectedValue == "false")
            {
                _shippingAddressSetting.NoShipping = false;
                _shippingAddressSetting.CustomShipping = false;
                _shippingAddressSetting.CustomDeliveryAddressObject = null;
            }
            else if (ddlNoShipping.SelectedValue == "true")
            {
                _shippingAddressSetting.NoShipping = true;
                _shippingAddressSetting.CustomShipping = false;
                _shippingAddressSetting.CustomDeliveryAddressObject = null;
            }

            #endregion

            #region Seller Info

            _ecPageUiSetting.EcHeaderImage = EcHeaderImage.Value;
            _ecPageUiSetting.EcBrandName = EcBrandName.Value;
            _ecPageUiSetting.EcCustomerServiceNumber = EcCustomerServiceNumber.Value;

            #endregion

            #region Buyer Info

            _buyerDetailsInfo.EcBuyerId = EcBuyerId.Value;
            _buyerDetailsInfo.EcBuyerUserName = EcBuyerName.Value;
            _buyerDetailsInfo.EcBuyerRegistrationDate = DateTime.Parse(EcBuyerRegistrationDate.Value);

            #endregion

            #region Insurance Info

            if (ddlInsuranceOptionOffered.SelectedValue == "true")
            {
                _paymentDetailsInfo.PaymentRequest_InsuranceOptionOffered = true;
                _paymentDetailsInfo.PaymentRequest_InsuranceTotalAmt = decimal.Parse(InsuranceTotalAmt.Value);
            }
            else if (ddlInsuranceOptionOffered.SelectedValue == "false")
            {
                _paymentDetailsInfo.PaymentRequest_InsuranceOptionOffered = false;
                _paymentDetailsInfo.PaymentRequest_InsuranceTotalAmt = decimal.Parse(InsuranceTotalAmt.Value);
            }

            #endregion

            #region Payment Info

            if (txtTransactionId.Text != string.Empty)
            {
                _paymentDetailsInfo.PaymentRequest_TransactionID = txtTransactionId.Text;
            }
            if (txtInvNum.Text != string.Empty)
            {
                _paymentDetailsInfo.PaymentRequest_InvNum = txtInvNum.Text;
            }
            if (txtInvNum.Text != string.Empty)
            {
                _paymentDetailsInfo.PaymentRequest_Custom = txtCustom.Text;
            }
            if (txtDesc.Text != string.Empty)
            {
                _paymentDetailsInfo.PaymentRequest_Desc = txtDesc.Text;
            }
            if (txtNoteToBuyer.Text != string.Empty)
            {
                _paymentDetailsInfo.PaymentRequest_NoteTxt = txtNoteToBuyer.Text;
            }

            #endregion

            #region All Amount Info

            _paymentDetailsInfo.PaymentRequest_ShippingTotalAmt = decimal.Parse(litShippingTotalAmtInfo.Text);
            _paymentDetailsInfo.PaymentRequest_ShipDiscAmt = decimal.Parse(litShippingDiscAmt.Value);
            _paymentDetailsInfo.PaymentRequest_ItemTotalAmt = decimal.Parse(litItemAmountInfo.Text);
            _paymentDetailsInfo.PaymentRequest_TaxTotalAmt = decimal.Parse(litTaxTotalAmtInfo.Value);
            _paymentDetailsInfo.PaymentRequest_HandlingTotalAmt = decimal.Parse(litHandlingTotalAmtInfo.Value);
            _paymentDetailsInfo.PaymentRequest_Amt = decimal.Parse(litTotalAmount.Text);
            //_paymentDetailsInfo.PaymentRequest_MaxAmount = decimal.Parse(litMaxAmountInfo.Text);

            #endregion

            MyanPaySoapCaller myanPaySoapCaller = new MyanPaySoapCaller();
            string retMsg = "";
            string token = "";
            bool ret = myanPaySoapCaller.SetExpressCheckOut(_allproductInfoViewObject, _shippingOptionViewObject, _ordersInfo,
                _paymentDetailsInfo,_shippingAddressSetting,_buyerDetailsInfo,_ecPageUiSetting,ref token, ref retMsg);

            if (ret)
            {
                Session["token"] = token;
                Response.Redirect(retMsg);
            }
            else
            {
                //Response.Write(retMsg);
                lblMessage.Text = retMsg;
            }
        }

        protected void ddlNoShipping_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (ddlNoShipping.SelectedValue == "true")
            {
                litShippingTotalAmtInfo.Text = "0";
                litShippingDiscAmt.Value = "0";
                litShippintDiscAmtInfo.Text = "0";

                litTotalAmount.Text = (decimal.Parse(litItemAmountInfo.Text) + decimal.Parse(litTaxTotalAmtInfo.Value) + decimal.Parse(InsuranceTotalAmt.Value) +
               decimal.Parse(litHandlingTotalAmtInfo.Value) + decimal.Parse(litShippingTotalAmtInfo.Text) + decimal.Parse(litShippingDiscAmt.Value)).ToString();

            }
            else if (ddlNoShipping.SelectedValue == "false")
            {
                if (optShipping0.Checked)
                {
                    shippingTotalAmt = decimal.Parse(ShippingOptionAmount0.Value);
                }
                if (optShipping1.Checked)
                {
                    shippingTotalAmt = decimal.Parse(ShippingOptionAmount1.Value);
                }
                if (optShipping2.Checked)
                {
                    shippingTotalAmt = decimal.Parse(ShippingOptionAmount2.Value);
                }
                if (optShipping3.Checked)
                {
                    shippingTotalAmt = decimal.Parse(ShippingOptionAmount3.Value);
                }
                if (optShipping4.Checked)
                {
                    shippingTotalAmt = decimal.Parse(ShippingOptionAmount4.Value);
                }

                litShippingTotalAmtInfo.Text = shippingTotalAmt.ToString();
                litShippingDiscAmt.Value = "-100";
                litShippintDiscAmtInfo.Text = "-100";

                litTotalAmount.Text = (decimal.Parse(litItemAmountInfo.Text) + decimal.Parse(litTaxTotalAmtInfo.Value) + decimal.Parse(InsuranceTotalAmt.Value) +
               decimal.Parse(litHandlingTotalAmtInfo.Value) + shippingTotalAmt + decimal.Parse(litShippingDiscAmt.Value)).ToString();

            }
        }
    }
}