﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using FloralExpressCheckOut.Class;

namespace FloralExpressCheckOut
{
	public partial class PaymentCompleted : System.Web.UI.Page
	{
	    private PaymentTransactionInfo paymentTransactionInfo;
        
        CartInfoRepository _cartInfoRepository;
	    private BasicResponseField basicResponseField;

		protected void Page_Load(object sender, EventArgs e)
		{
            paymentTransactionInfo = new PaymentTransactionInfo();
            _cartInfoRepository = new CartInfoRepository();
		    paymentTransactionInfo = (PaymentTransactionInfo) Session["PaymentDetail"];
            basicResponseField = (BasicResponseField)Session["BasicResponseField"];

            if (paymentTransactionInfo != null)
            {
                lblTransactionTypeName.Text = paymentTransactionInfo.PaymentInfo_TransactionTypeName;
                lblTransactionID.Text = paymentTransactionInfo.PaymentInfo_TransactionId;
                lblTotalAmount.Text = paymentTransactionInfo.PaymentInfo_TotalAmount.ToString();
                lblPaymentStatusName.Text = paymentTransactionInfo.PaymentInfo_PaymentStatusName;
                lblOrderTime.Text = paymentTransactionInfo.PaymentInfo_OrderTime.ToShortTimeString();
                lblFeeAmount.Text = paymentTransactionInfo.PaymentRequest_FeeAmount.ToString();
            }

            // Bind Basic Response Info [ Reply from MyanPay ]
            if (basicResponseField != null)
            {
                lblAck.Text = basicResponseField.Ack;
                lblBuild.Text = basicResponseField.Build;
                lblCorrelationID.Text = basicResponseField.CorrelationID;
                lblToken.Text = basicResponseField.Token;
                lblTimeStamp.Text = basicResponseField.TimeStamp;
                lblVersion.Text = basicResponseField.Version;
            }

            Guid memberId;
            memberId = (Guid)Session["floralMID"];
            _cartInfoRepository.DeleteCartInfoByMemberId(memberId);
		}
	}
}