﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Configuration;
using FloralExpressCheckOut.Class;
using System.Collections.Specialized;

namespace FloralExpressCheckOut
{
    public partial class index : System.Web.UI.Page
    {
        string connString = ConfigurationManager.ConnectionStrings["floralexpresscheckoutConnectionString"].ConnectionString;
        int productId;
        CartInfoRepository cartInfoRepository;
        ProductInfoRepository productInfoRepository;
        int TotalAmount = 0;
        int TotalQty = 0;
        
        protected void Page_Load(object sender, EventArgs e)
        {
            cartInfoRepository = new CartInfoRepository();
            productInfoRepository = new ProductInfoRepository();
            if (!Page.IsPostBack)
            {
                ShowProductInfo();
                ShowCartInfo();
                pnlCartInfo.Visible = false;
            }
         
        }

        protected void ShowProductInfo()
        {
            lvProductInfo.DataSource = productInfoRepository.GetProductInfosByAscending();
            lvProductInfo.DataBind();
        }
        //protected void imgbtnAddToCart_Click(object sender, ImageClickEventArgs e)
        //{
        //    int i = 1;
        //    Label1.Text += i;
        //    pnlCartInfo.Visible = true;
        //}
        protected void AddToCart(object sender, CommandEventArgs e)
        {

            if (Session["floralMID"] == null)
            {
                Guid MemberID = Guid.NewGuid();
                Session["floralMID"] = MemberID;
            }

            productId = int.Parse((string)e.CommandArgument);

            AddOrEditCartInfo();

            ShowCartInfo();

            lnkClearCart.Visible = true;
           
        }

        //Show Inserted Cart Item Message
        protected void ShowAddSuccessMessage()
        {
            Product ProductInfo = new Product();
            ProductInfo = productInfoRepository.GetProductInfoByProductID(productId);
            pnlCartMessage.Visible = true;
            lblMessage.Text = ProductInfo.ProductName + "  have been Insert in your Cart";
        }

        //Show Updated Cart Item Message
        protected void ShowUpdateSuccessMessage()
        {
            Product ProductInfo = new Product();
            ProductInfo = productInfoRepository.GetProductInfoByProductID(productId);
            pnlCartMessage.Visible = true;
            lblMessage.Text = ProductInfo.ProductName + "  have been Update in your Cart";
        }

        //Show Updated Cart Item Message When Text Change Event
        protected void ShowUpdateSuccessMessageByTextChanged(int qty,int cartId)
        {
            Cart CartInfo = new Cart();
            CartInfo = cartInfoRepository.GetCartInfoByCartID(cartId);
            Product ProductInfo = new Product();
            ProductInfo = productInfoRepository.GetProductInfoByProductID(CartInfo.ProductID);
            pnlCartMessage.Visible = true;
            lblMessage.Text = ProductInfo.ProductName + "  have been Update <span id='divSpecialFont'>" + qty + " Quantity </span> in your Cart";
        }

        //Show Cart Info
        protected void ShowCartInfo()
        {
            Guid? memberId = null;
            if (Session["floralMID"] != null)
            {
                memberId = (Guid)Session["floralMID"];
               

            }
            List<Cart> allCartInfoBymemberId = new List<Cart>();
            allCartInfoBymemberId = cartInfoRepository.GetCartInfoByMemberID(memberId);
            List<ProductInfoViewObject> allpoductInfoViewObject = new List<ProductInfoViewObject>();
            
            foreach (Cart cartInfoBymemeberId in allCartInfoBymemberId)
            {
                ProductInfoViewObject productInfoViewObject = new ProductInfoViewObject();

                Product currentProductInfo = new Product();
                currentProductInfo = productInfoRepository.GetProductInfoByProductID(cartInfoBymemeberId.ProductID);
                productInfoViewObject.ProductID = currentProductInfo.ProductID;
                productInfoViewObject.ProductName = currentProductInfo.ProductName;
                productInfoViewObject.Price = currentProductInfo.Price;
                productInfoViewObject.FilePath = currentProductInfo.FilePath;
                productInfoViewObject.Quantity = cartInfoBymemeberId.Quantity;
                productInfoViewObject.CartID = cartInfoBymemeberId.CartID;
                productInfoViewObject.ItemTotalAmount = productInfoViewObject.Quantity * productInfoViewObject.Price;
                TotalQty += productInfoViewObject.Quantity;
                TotalAmount += productInfoViewObject.ItemTotalAmount;
                allpoductInfoViewObject.Add(productInfoViewObject);

            }

            litTotal.Text = TotalAmount.ToString();
            litQty.Text = TotalQty.ToString();

            litAllTotal.Text = TotalAmount.ToString();
            lvCartInfo.DataSource = allpoductInfoViewObject;
            lvCartInfo.DataBind();
            pnlCartInfo.Visible = true;
        }

        //Quantity Change
        protected void txtQty_TextChanged(object sender, EventArgs e)
        {
            TextBox txtQty = sender as TextBox;
            Cart updateCart = new Cart();
            updateCart.CartID = int.Parse(txtQty.Attributes["CartID"]);
            updateCart.Quantity = int.Parse(txtQty.Text);
            updateCart.CartDate = DateTime.UtcNow.AddMinutes(390);
            cartInfoRepository = new CartInfoRepository();
            cartInfoRepository.UpdateCartInfo(updateCart);
            ShowUpdateSuccessMessageByTextChanged(int.Parse(txtQty.Text), int.Parse(txtQty.Attributes["CartID"]));
            ShowCartInfo();
        }
        
        //Save or Update Cart
        protected void AddOrEditCartInfo()
        {
            Cart CartInfoByProductIDAndMemberID = new Cart();
            CartInfoByProductIDAndMemberID = cartInfoRepository.GetCartInfoByProductIDAndMemberID(productId, (Guid)Session["floralMID"]);

            if (CartInfoByProductIDAndMemberID == null)
            {
                Cart newCart = new Cart();
                newCart.MemberID = (Guid)Session["floralMID"];
                newCart.ProductID = productId;
                newCart.Quantity = 1;
                newCart.CartDate = DateTime.UtcNow.AddMinutes(390);
                cartInfoRepository = new CartInfoRepository();
                cartInfoRepository.SaveCartInfo(newCart);
                ShowAddSuccessMessage();
            }
            else
            {
                Cart updateCart = new Cart();
                updateCart.CartID = CartInfoByProductIDAndMemberID.CartID;
                updateCart.Quantity = CartInfoByProductIDAndMemberID.Quantity + 1;
                updateCart.CartDate = DateTime.UtcNow.AddMinutes(390);
                cartInfoRepository = new CartInfoRepository();
                cartInfoRepository.UpdateCartInfo(updateCart);
                ShowUpdateSuccessMessage();
            }
        }
        
        //Delete Cart Item
        protected void DeleteItem(object sender, CommandEventArgs e)
        {
            int cartId;
            cartId = int.Parse((string)e.CommandArgument);
            cartInfoRepository.DeleteCartInfo(cartId);
            pnlCartMessage.Visible = false;
            ShowCartInfo();
        }

        //Clear Cart
        protected void lnkClearCart_Click(object sender,EventArgs e)
        {
            Guid memberId;
            memberId = (Guid)Session["floralMID"];
            cartInfoRepository.DeleteCartInfoByMemberId(memberId);
            ShowCartInfo();
            pnlCartInfo.Visible = false;
            lnkClearCart.Visible = false;
        }

        //View Cart
        protected void lnkViewCart_Click(object sender, EventArgs e)
        {
            ShowCartInfo();
            pnlCartMessage.Visible = false;
        }

      
    }
}